#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#include "acidblood.h"
#include "acidfuncs.h"
#include "tracking.h"
#include "events.h"

#include "resistor.c"

session_t session;

/*
struct sessions {
	struct sessions *prev ;   
	session_t session;
	struct sessions *next ;
} ;
*/

int resistormod_start(char *, struct userlist *, char *);
void resistormod_answer(int event, struct socket_info *sinfo, char *nick, char *dest, char *info);
int relventAnswer(char *text);


int module_init(void *module)
{
        addtrigger(module, EV_MSG, resistormod_answer );
	addusrcommand(module, "doresistors", resistormod_start, 99);
        	
	return(0) ;
}

int module_shutdown(void *module)
{
        deltrigger(module, EV_MSG );
	delusrcommand(module, "doresistors");
	
	return(0) ;
}


int resistormod_start(char *replyto, struct userlist *user, char *data)
{
	struct socket_info *socket ;
        int rounds;
        char computer[Q_LEN];
        
	socket=user->userinfo->server->sinfo ;
             
        if (data == NULL) {
		privmsg(socket,replyto,
			"useage: doresistors number_of_resistors_to_do\n");
		return(0) ;
	}
                
        data = strtok(data, " ");
	rounds = atoi(data);
              
        startSession( &session, rounds );
        strncpy(session.student,  user->userinfo->nick, 32);
                    
        sessionQuestion( &session, computer );               
                        
        if (!sessionActive( &session )){
          strcpy(session.student, "");
          return 0; 
        }
        
 	privmsg(socket, replyto, "%s: %s",session.student, computer);               
                
	return(0) ;
	
};


void resistormod_answer(int event, struct socket_info *sinfo, char *nick, char *dest, char *info) {

  char computer[Q_LEN];
  char answer[Q_LEN];
  
  // is this comming from someone I'm listening to?
  if ( strcmp(nick, session.student) !=0) return;
  
  // is this an answer of any kind?
  if ( !relventAnswer(info) ) return; 

  info = strtok(info, " ");

   // was it right?
   sessionAnswer( &session, info, answer);
     
    // next question 
   sessionQuestion( &session, computer );   
         
   if (sessionActive( &session )) {            
     privmsg(sinfo, dest,"%s: %s %s",session.student, answer, computer);
   } else {
    sessionScore(&session, computer);
    privmsg(sinfo, dest,"%s: %s %s",session.student, answer, computer);
    strcpy(session.student, "");
   }
  
  return;
  
}

int relventAnswer(char *text) {

  char answers[] = { 
              "black brown red orange yellow green blue violet grey white purple gray 0 1 2 3 4 5 6 7 8 9 "
                   };

  char * test;

  if (text == NULL) return 0;
  test = strtok(text, " ");
  strcat(test, " ");
  
  if (strstr(answers, test) != NULL) {
    return 1;
  } else {
    return 0;
  }
  
}






















